package jalview.ext.archaeopteryx;

import jalview.analysis.NJTree;
import jalview.analysis.TreeBuilder;
import jalview.analysis.scoremodels.ScoreModels;
import jalview.analysis.scoremodels.SimilarityParams;
import jalview.api.analysis.ScoreModelI;
import jalview.api.analysis.SimilarityParamsI;
import jalview.bin.Jalview;
import jalview.datamodel.Alignment;
import jalview.datamodel.AlignmentI;
import jalview.datamodel.Sequence;
import jalview.datamodel.SequenceI;
import jalview.gui.AlignViewport;

import org.forester.archaeopteryx.MainFrame;
import org.forester.archaeopteryx.TreePanel;
import org.forester.phylogeny.Phylogeny;
import org.testng.annotations.BeforeClass;
import org.testng.annotations.Test;

public class AptxJalviewTreeTest extends TreeViewTest
{
  TreeBuilder jalviewTree;

  TreePanel treePanel;

  Phylogeny tree;

  MainFrame aptx;

  Jalview jalview;
  
  @Override
  @BeforeClass(alwaysRun = true)
  public void setUpTree()
  {
    SequenceI seq1 = new Sequence("Seq1", "ABCDEFGHIJ");
    SequenceI seq2 = new Sequence("Seq2", "ABCDEFTHIJ");
    SequenceI seq3 = new Sequence("Seq3", "BCFWDHIJ");
    SequenceI seq4 = new Sequence("Seq4", "WTHISTHIS");

    AlignmentI al = new Alignment(
            new SequenceI[]
            { seq1, seq2, seq3, seq4 });
    AlignViewport alignViewport = new AlignViewport(al);

    ScoreModelI scoreModel = ScoreModels.getInstance().getBlosum62();
    SimilarityParamsI similarityParams = new SimilarityParams(true, true,
            true, false);

    jalviewTree = new NJTree(alignViewport, scoreModel,
            similarityParams);
  }

  @Override
  @BeforeClass(dependsOnMethods = { "setUpTree" })
  public void createTreeView()
  {
    treeView = ArchaeopteryxInit.createInstance(jalviewTree);
    aptx = (MainFrame) treeView; // still pretty ugly

    treePanel = aptx.getMainPanel().getCurrentTreePanel();
    tree = treePanel.getPhylogeny();
  }

  @Override
  public void testChildNodesCount()
  {
    // TODO Auto-generated method stub

  }

  @Override
  public void testChildToParentBranchLength()
  {
    // TODO Auto-generated method stub

  }

  @Override
  public void testNodeToRootBranchLength()
  {
    // TODO Auto-generated method stub

  }

  @Override
  public void testDistantNodeToRootBranchLength()
  {
    // TODO Auto-generated method stub

  }

  @Override
  public void testTreeLoaded()
  {
    // TODO Auto-generated method stub

  }


  @Test(
    groups = "Functional",
    expectedExceptions = IllegalArgumentException.class)
  public void testInvalidBranchName()
  {
    // TODO Auto-generated method stub

  }

  @Override
  public void testExistingBranchName()
  {
    // TODO Auto-generated method stub

  }
}
